# kinect2_tracker

A fork of https://github.com/mcgi5sr2/kinect2_tracker (ROS wrapper for Kinect One using libfreenect2) with experimental support for joint orientations and done in the  https://github.com/smihael/kinect2_tracker


This ROS package enables the use of Kinect skeletons in Linux.

## install 

> Their installation guide is very short but I would suggest to look into the docs about it here: https://www.programmersought.com/article/8643987279/

### [Install libfreenect2](https://github.com/OpenKinect/libfreenect2/)
1. Download the libfreenect2 resource:
```
git clone https://github.com/OpenKinect/libfreenect2.git
cd libfreenect2
```
2. Download the update package:
```
cd depends
./download_debs_trusty.sh
```
3. Installation tools:
```
sudo apt-get install build-essential cmake pkg-config
```
4. Install libusb:
```
sudo dpkg -i debs/libusb*deb
```
5. Install TurboJPEG
```
sudo apt-get install libturbojpeg libjpeg-turbo8-dev
```
6. Install OpenGL
```
sudo dpkg -i debs/libglfw3*deb
sudo apt-get install -f
```
7. Install OpenCL (optional) - GPU acceleration:
is not installed here. If you need to install it, please refer to the related documentation. You can use the following code to install it.
```
sudo apt-get install opencl-headers
```
8. Install OpenNI2
kinect is a Microsoft device, so it has kinect.dll, and only the adapter driver developed by experts on Linux. According to the current information on the Internet, OpenNi is not compatible with v2, and the v2 driver is developed by OpenNi2 and has not been developed with OpenNi. Therefore, for v1 devices, only OpenNi needs to be installed, and for v2 devices, OpenNi2 needs to be installed.
```
 sudo apt-add-repository ppa:deb-rob/ros-trusty
 sudo apt-get update
 sudo apt-get install libopenni2-dev
```
9. Compile libfreenect2
```
cd ~/libfreenect2
mkdir build && cd build
cmake .. -DENABLE_CXX11=ON -DCMAKE_INSTALL_PREFIX=/usr/
make
sudo make install
```
10. Get device permissions
```
sudo cp platform/linux/udev/90-kinect2.rules /etc/udev/rules.d/
```
11. Testing
```
cd ~/libfreenect2/build
./bin/Protonect
```
If the image is output, the installation is successful.


### [Install NiTE2](https://gitlab.inria.fr/kinect/nite)

1. [Download NiTE2](https://gitlab.inria.fr/kinect/nite) and 
```
git clone git@gitlab.inria.fr:kinect/nite.git
cd nite/NiTE-Linux-x64-2.2
sudo ./install.sh
```
2. Copy the contents of the `NiTedevEnvironment` file to your `.bashrc` file
3. Modify the rest of the environment:
```
cd NiTE/Samples/Bin/
nano OpenNI.ini
```
Add a Repository=/usr/lib/OpenNI2/Drivers (that is, install the driver path generated by openni2)
4. Test
```
cd NiTE/Samples/Bin/
./UserViewer
```
If everything vent well, you'll see the bone map.
![](https://images4.programmersought.com/952/db/dbb05ebeb6b63fe982647ff9b6455678.png)

### Prepare for ROS

1. Prepare  the envs
 Modify `CMakeList.txt` and to point to your instal:ation of the NiTE and then run (line 90 - 92):
 ```cmake
set(NITE2_DIR ~/kinect_ws/src/kinect2_tracker/NiTE-Linux-x64-2.2/)
set(NITE2_LIB ~/kinect_ws/src/kinect2_tracker/NiTE-Linux-x64-2.2/Redist/libNiTE2.so)
 ```

Do the same to the`setup_nite.bash`: 
 ```sh
 ln -s ~/kinect_ws/src/kinect2_tracker/NiTE-Linux-x64-2.2/Samples/Bin/NiTE2/ ~/.ros/NiTE2
 ```
 And then just run:
 ```sh
 source setup_nite.bash
 ```

2. Compile
```sh
catkin build
```
3. Test

```bash
roslaunch kinect2_tracker tracker.launch
```

## API

### Published

- `/people_skeleton` : `kinect2_tracker::user_IDs`, id array of the tracked people
- `/people_points`: `kinect2_tracker::user_points`, center of mass for each person
- `/people_points_viz`: `visualization_msgs::Marker`, people points to show in `rviz`
- `tf` transforms for the human skeletons 
- Kinect RGB, depth and infrad images

### Params

- `tf_prefix`: The prefirx when publishing tf
- `relative_frame`: The base frame of the Kinect observations
